// Copyright 2012 by Jon Dart. All Rights Reserved.
#ifndef _LOCK_H
#define _LOCK_H

#include "types.h"

class ScopedLock {

 public:

    // create a scoped lock. The passed-in lock must have
    // been initialized.
    ScopedLock(lock_t lock) :
   lockObj(lock) {
        Lock(lockObj);
    }

    // unlock when this obj goes out of scope
    ~ScopedLock() {
        Unlock(lockObj);
    }

 private:
    lock_t lockObj;
};


#endif
